/* extends QueryString to provide query transformation for non OO utility 
   procedure that manages multiple datasources as 4GL handles */ 

using com.openedge.framework.util.query.*.
    
CLASS com.openedge.framework.util.query.DSQueryString 
                           INHERITS QueryString
                           IMPLEMENTS IQueryMap:

  DEFINE PRIVATE VARIABLE mhProcedure AS handle    NO-UNDO.
  DEFINE PRIVATE VARIABLE mcTable     AS character NO-UNDO.

  CONSTRUCTOR PUBLIC DSQueryString (pcQueryString AS CHAR,
                                    phProcedure   AS HANDLE,
                                    pcTable       AS character ):
    /* SUPER must be first call, so pass blank to postpone parsing untill 
       we have set the procedure handle for the call backs */
    SUPER ('',THIS-OBJECT).
    ASSIGN
      mhProcedure  = phProcedure
      mcTable      = pcTable.
    parseQuery(pcQuerySTring).
  END.
  
  METHOD PUBLIC CHARACTER columnSource (pcColumn AS CHAR):
    RETURN DYNAMIC-FUNCTION('sourceColumn' IN mhProcedure,mcTable,pcColumn). 
  END.
  
  METHOD PUBLIC CHARACTER defaultQuery (): 
    RETURN DYNAMIC-FUNCTION('sourceDefaultQuery' IN mhProcedure,mcTable). 
  END.
END.
