/*------------------------------------------------------------------------------
 File        : beOrder.p
 Description : Business Entity for Order
 Notes       : This is a sample (prototype) for illustrative purposes only 
              - No parameters for batch or query
              - No BL
------------------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
{schema/dsOrder.i} 
/* ************ Property Storage ************************************/
define variable ghService as handle no-undo.       
define variable ghDataAccessObject as handle no-undo.       
  
/* ***************************  ProtoTypes **************************** */
function getService  returns handle private (  ) forward.
function setService  returns logical ( phHandle as handle ) forward.

/* ************ Main Block ****************************************/  
ghService = source-procedure.

/* ************ Functions ****************************************/                           
function getDataAccessObject returns handle private  
  (  ):
  if not valid-handle(ghDataAccessObject) then  
    ghDataAccessObject = dynamic-function('startDataAccess' in getService(),
                                           this-procedure).
  return ghDataAccessObject.                                           
end.       

function getService  returns handle private 
  (  ):
  return ghService.
end.

function setService  returns logical ( phHandle as handle ) :
  ghService = phHandle.
  return true.
end.
        
/* ************ Procedures ****************************************/        
procedure fetchDataset:
/*------------------------------------------------------------------------------
  Purpose:  Fetch empty dataset  
 -----------------------------------------------------------------------------*/
  define output parameter dataset for dsOrder.
end. /* fetchData */ 

procedure fetchData:
/*------------------------------------------------------------------------------
  Purpose:  Fetch data       
Parameters:  phDataSet      - Prodataset handle (not dataset-handle) 
 -----------------------------------------------------------------------------*/
  define output parameter dataset for dsOrder.  
  run fetchData in getDataAccessObject()  (output dataset dsOrder by-reference).                                          
end. /* fetchData */ 

procedure saveChanges:
/*------------------------------------------------------------------------------
   Purpose:  Save data                
Parameters: phDataSet      - Prodataset with changes   
----------------------------------------------------------------------------*/
  define input-output parameter dataset for dsOrder.
  run saveChanges in getDataAccessObject() (input-output dataset dsOrder by-reference).                               
end. /* savechanges */ 

procedure destroyObject:
  dynamic-function('stopDataAccess' in getService(),this-procedure). 
  delete procedure this-procedure.  
end. /* destroyObject */    
    

       
       
       