&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
/* Procedure Description
"ADM dynamic DataView object.
Defines a view on a prodataset."
*/
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS dTables 
/*************************************************************/
/* Copyright (c) 1984-2005 by Progress Software Corporation  */
/*                                                           */
/* All rights reserved.  No part of this program or document */
/* may be  reproduced in  any form  or by  any means without */
/* permission in writing from PROGRESS Software Corporation. */
/*************************************************************/
/*------------------------------------------------------------------------

  File:  

  Description: DYNDATAVIEW.W - Dynamic DataView object in the ADM

  Input Parameters:
      <none>

  Output Parameters:
      <none>

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/
/* ***************************  Definitions  ************************** */
/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.


/* tell smart.i that we can use the default destroyObject */ 
&SCOPED-DEFINE include-destroyobject

/* excluding prototypes reduces start up overhead significantly */
&SCOPED-DEFINE adm-exclude-prototypes

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDataObject
&Scoped-define DB-AWARE no

&Scoped-define ADM-SUPPORTED-LINKS Data-Source,Data-Target,Navigation-Target,Update-Target,Commit-Target,Filter-Target


/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */


/* ************************  Frame Definitions  *********************** */


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDataObject
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: PERSISTENT-ONLY COMPILE
 */

/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW dTables ASSIGN
         HEIGHT             = 1.57
         WIDTH              = 61.6.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB dTables 
/* ************************* Included-Libraries *********************** */

{src/adm2/dataview.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW dTables
  VISIBLE,,RUN-PERSISTENT                                               */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK dTables 


/* ***************************  Main Block  *************************** */
  &IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN          
    RUN initializeObject.
  &ENDIF

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE buildDataRequest dTables 
PROCEDURE buildDataRequest :
/*------------------------------------------------------------------------------
  Purpose:  Override to avoid join of entities on server 
  Parameters:  
  Notes: This customization hijacks openoininit and would make any user setting 
         of this property for child DataViews on separate entities 
         non-functional.         
         If this is a problem just add a new property like SplitRequest for this
         purpose. it would also simplify the logic in startObject      
------------------------------------------------------------------------------*/

  DEFINE INPUT        PARAMETER phOwner          AS HANDLE NO-UNDO.
  DEFINE INPUT        PARAMETER pcDataSource     AS CHARACTER NO-UNDO.
  DEFINE INPUT        PARAMETER pcViewerSource   AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcRequests       AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcDataTables     AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcQueries        AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcBatchSizes     AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcForeignFields  AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcPositionFields AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcContext        AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcDatasetSources AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcEntities       AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcEntityNames    AS CHARACTER NO-UNDO.
    
  /* ignore request if issued from different entity instance */
  if (pcDataSource > '' and pcDataSource <> dynamic-function('getDataSetName')) 
  or (pcViewerSource > '' and pcViewerSource <> dynamic-function('getDataSetName')) then  
  do:
    if dynamic-function('getOpenOnInit') = true then
    do:
      if dynamic-function('getObjectInitialized') = true then 
        return.
      dynamic-function('setOpenOnInit',false). 
    end.  
  end.
  run super(phOwner, pcDataSource, pcViewerSource, INPUT-OUTPUT pcRequests, INPUT-OUTPUT pcDataTables, INPUT-OUTPUT pcQueries, INPUT-OUTPUT pcBatchSizes, INPUT-OUTPUT pcForeignFields, INPUT-OUTPUT pcPositionFields, INPUT-OUTPUT pcContext, INPUT-OUTPUT pcDatasetSources, INPUT-OUTPUT pcEntities, INPUT-OUTPUT pcEntityNames).
  
 END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI dTables  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE startObject dTables 
PROCEDURE startObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/
  define variable hDataSource     as  handle  no-undo.
  define variable hPositionSource as  handle  no-undo.
  define variable lOpenOnInit     as  logical no-undo.
  define variable cEntityName     as  logical no-undo.
  
  RUN SUPER.
  /* buildDataRequest override sets openoninit false in order to avoid 
     joining entities  
    (This customization hijacks openoininit and would make any user setting 
     of this property for child DataViews on spearate entities non functional. 
     If this is a problem  just add a new property like SplitRequest for this
     purpose (This would also simplify this code as you only need to check
     the property) */
  
  lOpenOnInit = dynamic-function("getOpenOnInit"). 
  if lOpenOnInit = false then 
  do:
    assign    
      hDataSource     = dynamic-function("getDataSource")   
      hPositionSource = dynamic-function("getPositionSource")   
      cEntityName     = dynamic-function("getDataSetName").
    if valid-handle(hDataSource) 
    and cEntityName <> dynamic-function("getDataSetName",hDataSource) then
      dynamic-function("OpenQuery").
    else if valid-handle(hPositionSource)     
    and cEntityName <> dynamic-function("getDataSetName",hDataSource) then
      dynamic-function("OpenQuery").
  end.    
    
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

