/*------------------------------------------------------------------------------
 File        : daOrder order data access   
 Description : Example/prototype code with all static and no super code
 Notes       : 
             - fetchData supports conditional retrieval of tables
             - All request methods are statefree (attaches and detaches sources) 
               and passes dataset around  by-reference. (no get or set)
             - attach and detach methods with no event definitions 
             - Implements saveChanges with each order and child orderlines
               in same transaction. 
             - saveChanges set rejected flag in orderlines backed out of 
               transaction.          
 ------------------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
/* defines dataset include and loads daSupport as super */ 
{support/daEntity.i Customer} 

define data-source dCustomer for Customer.
define data-source dSalesrep for Salesrep.
 
/* ************ Functions ****************************************/           

function sourceDefaultQuery returns character  
  (pcTable as char):
  case pcTable:
    when 'eCustomer' then 
      return 'for each customer indexed-reposition'.
  end.    
end.

function sourceColumn returns character  
  (pcTable as char, 
   pcColumn as char ):
  define variable cMap  as character no-undo.
  case pcTable:
    when 'eCustomer' then
    do: 
      cMap = data-source dCustomer:get-dataset-buffer:data-source-complete-map.
    end.  
  end.
  return entry(lookup(pccolumn,cMap) + 1,cMap).
end.

   
/* ************ Procedures ****************************************/        
procedure attachDataSources:
  define input-output parameter dataset for dsCustomer.

  buffer eCustomer:attach-data-source(data-source dCustomer:handle).        
  buffer eSalesrep:attach-data-source(data-source dSalesrep:handle).  
end.   

       