/*------------------------------------------------------------------------
    File        : beEntity.i
    Purpose     : define static instance that loads beSupport super
    Syntax      : {support/beentity.i <EntityName>}

    Description : Include for super bootstrapping 

    Author(s)   : hdaniels
    Created     : Wed May 23 09:28:14 EDT 2007
    Notes       : There must be a dataset include in propath of name 
                 {&schemapath}/{&datasetprefix}{&entityname}.i  
                 default = schema/ds<Entityname>.i
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
{support/startsuper.i} 

/* Allow external named preprocessor, but let numbered arguments override */ 
&if "{1}" <> "" &then 
  &scop entityname {1}
&endif 

&if "{2}" <> "" &then 
  &scop schemapath {2}
&elseif defined(schemapath) = 0 &then
  &scop schemapath schema 
&endif 

&if "{3}" <> "" &then 
  &scop datasetprefix {3}  
&elseif defined(datasetprefix) = 0 &then 
  &scop datasetprefix ds
&endif

&if defined(entityname) <> 0 &then
{{&schemapath}/{&datasetprefix}{&entityname}.i}

/* **************************  Main Block  *************************** */
startSuper('beSupport').

run createObject.
/* ************ Functions ****************************************/   
function getStaticDataset returns handle():
  return dataset {&datasetprefix}{&entityname}:handle.
end.

function getEntityName returns character():
  return "{&entityname}".
end.

&endif
