/*************************************************************/
/* Copyright (c) 2007 by Progress Software Corporation      */
/*************************************************************/
/*------------------------------------------------------------------------------
    File   :   fetchdata.p
    Purpose:  Fetch data and/or definitions for a Business Entity
              on an appserver. (service gateway)  
    Notes  : 
   Parameters:  
     pcEntity       - Business Entity 
     pcTables       - Tables for which to retrieve data or definitions
     pcQueries      - List of queries that corresponds to the requested tables
     pcRequest      - The actual request for the tables   
     pcContext      - context
     phDataSet      - Prodataset handle 
 -----------------------------------------------------------------------------*/
define input        parameter pcEntity       as character no-undo.
define input        parameter pcTables       as character no-undo.
define input        parameter pcQueries      as character no-undo.
define input        parameter pcRequests     as character no-undo.
define input        parameter piNumRecords   as integer   no-undo.
define input-output parameter pcContext      as character no-undo.
define output       parameter dataset-handle phDataSet .

define variable ghService as handle no-undo.
 
 /* defines locateProcedure used by getService to start/locate service */
{support/locateprocedure.i}
/* ************************  Function Prototypes ********************** */
function newDataset returns handle private  
  ( pcEntity as character) forward.

function getService returns handle private 
  (  )  forward .

/*************************** Main block **************************/

/* Workaround problem if BE has defined input-output dataset static
   in fetchData method. (This will bind to static if called with unknown
   value and force us to keep the BE alive.)  */ 
phDataset = newDataset(pcEntity).

if pcTables > '' and pcRequests <> 'DEFS' then 
do:  
  run fetchData in getService() (pcEntity,
                                 pcTables,
                                 pcQueries,
                                 pcRequests,
                                 piNumRecords,
                                 input-output pcContext,
                                 input-output phDataset) no-error.
  if error-status:error then 
    return error if return-value > '' then return-value else error-status:get-message(1).
 
  run stopEntity in getService() (pcEntity).                                    
end. 

/* ************************  Function Implementations ***************** */

/* Returns a new empty dataset instance  
  (we want dynamic instances in order to not keep BE alive)  */
function newDataset returns handle private  
  ( pcEntity as character):
  define variable hDataset as handle no-undo. 
  define variable cContext as character no-undo.
  define variable hNewDataset as handle no-undo. 
  
  run fetchDataset in getService() (pcEntity,output hDataset).
  if valid-handle(hDataset) then
  do:                               
    create dataset hNewDataset.   
    hNewDataset:create-like(hDataset).   
  end.   
  return hNewDataset.
end.

/* get service locates it on first call  */
function getService returns handle private 
  (  ):
  if not valid-handle(ghService) then 
    ghService = locateProcedure('service').
  return ghService. 
end.

